package com.futu.course.cupons.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.futu.course.common.utils.CopyUtil;
import com.futu.course.cupons.domain.Coupon;
import com.futu.course.cupons.service.CouponService;
import com.futu.course.cupons.mapper.CouponMapper;
import com.futu.course.user.domain.User;
import com.futu.course.user.domain.UserCoupon;
import com.futu.course.user.mapper.UserCouponMapper;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
* @author yuu
* @description 针对表【coupon(优惠券)】的数据库操作Service实现
* @createDate 2025-05-05 18:53:35
*/
@Service
public class CouponServiceImpl extends ServiceImpl<CouponMapper, Coupon>
    implements CouponService{

    @Resource
    private UserCouponMapper userCouponMapper;

    @Resource
    private RedisTemplate redisTemplate;

    @Override
    public List<Coupon> findAll(BigDecimal primary) {
        User user = (User) redisTemplate.opsForValue().get("user");
        List<Long> objects = userCouponMapper.selectObjs(new QueryWrapper<UserCoupon>().eq("user_id", user.getId()).eq("status", 0).select("coupon_id"));
        if (objects == null){
            return null;
        }
        List<Coupon> list=new ArrayList<>();
        for (Long i:objects){
            list.add(this.baseMapper.selectOne(new QueryWrapper<Coupon>().eq("id",i).ge("condition_amount",primary)));
        }
        if (list==null){
            return null;
        }
        return list;
    }
}




